<!-- https://eugenkiss.github.io/7guis/tasks#crud -->
<script lang="ts">
  import { createProductTypeAPI } from "src/apis/create-product-type";
  import { deleteProductTypeAPI } from "src/apis/delete-product-type";
  import { getProductTypeAPI } from "src/apis/get-product.type";
  import { updateProductTypeAPI } from "src/apis/update-product-type";
  import type { ProductTypeModel } from "src/models/product.type.type";
  import { productTypeListStore } from "src/store";

  import { onMount } from "svelte";

  let disable = false;

  // **** Type
  let productTypeList: ProductTypeModel[] = [];
  let customCss: string = "";

  let typeName = "";
  let iconTypeUrl: string = "";
  let typeSelectIndex = 0;

  async function updateTypeAPI() {
    await updateProductTypeAPI(selectedProductType);
    await reloadCallApi();
  }

  async function createTypeAPI(productType: ProductTypeModel) {
    await createProductTypeAPI(productType);
    await reloadCallApi();
  }

  async function deleteTypeAPI(uuid: string) {
    if (uuid) {
      await deleteProductTypeAPI(uuid);
      await reloadCallApi();
    }
  }

  $: filterTypeList = productTypeList;

  $: selectedProductType = filterTypeList[typeSelectIndex];

  $: reset_type_inputs(selectedProductType);

  async function createType() {
    productTypeList = productTypeList.concat({
      typeName: typeName,
      icon: iconTypeUrl,
    });
    typeSelectIndex = productTypeList.length - 1;

    await createTypeAPI({
      typeName: typeName,
      icon: iconTypeUrl,
    });

    typeName = "";
    iconTypeUrl = "";
  }

  async function updateType() {
    selectedProductType.typeName = typeName;
    selectedProductType.icon = iconTypeUrl;
    productTypeList = productTypeList;
    await updateTypeAPI();
  }

  async function removeType() {
    // Remove selectedProductType person from the source array (productTypeList), not the filtered array
    const index = productTypeList.indexOf(selectedProductType);
    productTypeList = [
      ...productTypeList.slice(0, index),
      ...productTypeList.slice(index + 1),
    ];

    await deleteTypeAPI(selectedProductType.uuid || "");

    typeName = "";
    iconTypeUrl = "";
    typeSelectIndex = Math.min(typeSelectIndex, filterTypeList.length - 2);
  }

  function reset_type_inputs(type: any) {
    typeName = type ? type.typeName : "";
    iconTypeUrl = type ? type.icon : "";
  }

  onMount(async () => {
    await reloadCallApi();
  });

  async function reloadCallApi() {
    await getProductTypeAPI();

    productTypeList = $productTypeListStore;
  }
</script>

<div class="w-full p-5 rounded bg-indigo-700 mx-3 mt-5">
  <p class="text-white">จัดการประเภทสินค้า</p>
  <div class="flex flex-col p-3 bg-gray-200 rounded {customCss}">
    <select class="rounded" bind:value={typeSelectIndex} size={10}>
      {#each filterTypeList as typeData, typeSelectIndex}
        <option value={typeSelectIndex}
          >{typeSelectIndex + 1}. {typeData.typeName}
        </option>
      {/each}
    </select>

    {#if !disable}
      <p>ชื่อประเภท</p>
      <input
        type="text"
        class="p-2 my-1 rounded"
        bind:value={typeName}
        placeholder="ชื่อประเภท"
      />

      <div class="flex items-center">
        ไอคอนชื่อ (Url Image)
        {#if iconTypeUrl}
          <img class="w-10 h-10 mx-4 rounded" src={iconTypeUrl} />
        {/if}
      </div>
      <input
        type="text"
        class="p-2 my-1 rounded"
        bind:value={iconTypeUrl}
        placeholder="ไอคอนชื่อ (Url Image)"
      />

      <div class="w-full sm:flex md:flex lg:flex">
        <button
          class="bg-green-500 hover:bg-green-600 text-white p-2 cursor-pointer w-full"
          on:click={createType}
          disabled={!typeName || !iconTypeUrl}>create</button
        >
        {#if selectedProductType?.uuid}
          <button
            class="bg-yellow-500 hover:bg-yellow-600 text-white p-2 cursor-pointer w-full"
            on:click={updateType}
            disabled={!typeName || !iconTypeUrl || !selectedProductType}
            >update</button
          >
          <button
            class="bg-red-500 hover:bg-red-600 text-white p-2 cursor-pointer w-full"
            on:click={removeType}
            disabled={!selectedProductType}>delete</button
          >
        {/if}
      </div>
    {/if}
  </div>
</div>
